/// <reference types="node" />
import { AnyPublicKey, Borsh, Account } from '@metaplex-foundation/mpl-core';
import { AccountInfo, PublicKey } from '@solana/web3.js';
import { Buffer } from 'buffer';
import { MetaplexKey } from '../MetaplexProgram';
declare type Args = {
    settingsUri: string;
};
export declare class StoreConfigData extends Borsh.Data<Args> {
    static readonly SCHEMA: any;
    key: MetaplexKey;
    settingsUri: string;
    constructor(args: Args);
}
export declare class StoreConfig extends Account<StoreConfigData> {
    constructor(pubkey: AnyPublicKey, info: AccountInfo<Buffer>);
    static isCompatible(data: Buffer): boolean;
    static getPDA(store: AnyPublicKey): Promise<PublicKey>;
}
export {};
