import { Borsh, TupleNumericType, Transaction } from '@metaplex-foundation/mpl-core';
import { ParamsWithStore } from '@metaplex-foundation/mpl-token-vault';
import { PublicKey, TransactionCtorFields } from '@solana/web3.js';
import BN from 'bn.js';
export declare class InitAuctionManagerV2Args extends Borsh.Data<{
    amountType: TupleNumericType;
    lengthType: TupleNumericType;
    maxRanges: BN;
}> {
    static readonly SCHEMA: any;
    instruction: number;
    amountType: TupleNumericType;
    lengthType: TupleNumericType;
    maxRanges: BN;
}
declare type InitAuctionManagerV2Params = {
    vault: PublicKey;
    auction: PublicKey;
    auctionManager: PublicKey;
    auctionManagerAuthority: PublicKey;
    acceptPaymentAccount: PublicKey;
    tokenTracker: PublicKey;
    amountType: TupleNumericType;
    lengthType: TupleNumericType;
    maxRanges: BN;
};
export declare class InitAuctionManagerV2 extends Transaction {
    constructor(options: TransactionCtorFields, params: ParamsWithStore<InitAuctionManagerV2Params>);
}
export {};
