import { Borsh, Transaction } from '@metaplex-foundation/mpl-core';
import { ParamsWithStore } from '@metaplex-foundation/mpl-token-vault';
import { PublicKey, TransactionCtorFields } from '@solana/web3.js';
import BN from 'bn.js';
export declare class RedeemParticipationBidV3Args extends Borsh.Data<{
    winIndex: BN | null;
}> {
    static readonly SCHEMA: any;
    instruction: number;
    winIndex: BN | null;
}
declare type RedeemParticipationBidV3Params = {
    vault: PublicKey;
    auction: PublicKey;
    auctionManager: PublicKey;
    bidRedemption: PublicKey;
    bidMetadata: PublicKey;
    safetyDepositTokenStore: PublicKey;
    destination: PublicKey;
    safetyDeposit: PublicKey;
    bidder: PublicKey;
    safetyDepositConfig: PublicKey;
    auctionExtended: PublicKey;
    metadata: PublicKey;
    prizeTrackingTicket: PublicKey;
    newMetadata: PublicKey;
    newEdition: PublicKey;
    masterEdition: PublicKey;
    newMint: PublicKey;
    editionMark: PublicKey;
    winIndex: BN;
    transferAuthority: PublicKey;
    acceptPaymentAccount: PublicKey;
    tokenPaymentAccount: PublicKey;
};
export declare class RedeemParticipationBidV3 extends Transaction {
    constructor(options: TransactionCtorFields, params: ParamsWithStore<RedeemParticipationBidV3Params>);
}
export {};
